header {* Hume specialisation of TLA rules  *}

theory EvenOdd
imports Integrated
begin

constdefs
 emptyHeap :: "Heap"
 "emptyHeap == fimap(empty)"

consts
  deepcopy :: "HoVal \<Rightarrow> Heap \<Rightarrow> Heap \<Rightarrow> (HoVal*Heap)"

(*
consts hovsize :: "HoVal \<Rightarrow> nat" 
primrec
  "hovsize BOTTOM = 0"
  "hovsize (I i) = 0"
  "hovsize (B b) = 0"
  "hovsize (R ref) = 
     (case ref of
          Nullref \<Rightarrow> 0
       |  Ref loc \<Rightarrow> hovsize loc)"

*)
(* maybe use domain as a measure ??? 
   maybe restriction on fmap??? 
   remove ref from dom !! in rec call *)  

(* see inductive definitions of mList in ListCopy.thy
   and regConstr in ../HAM/Derived.thy for collecting
   all addresses covered by a data structure;
   maybe use this with a restrict_map to define the
   heap obtained by a deep copy               -- HWL *)

(*
primrec
  "deepcopy (C n refs) h h' = ((C n refs),h')" 
  "deepcopy (X fname n refs) h h' = ((X fname n refs),h')"

consts 
  tsize :: "HoVal \<Rightarrow> Heap \<Rightarrow> Heap \<Rightarrow> nat"

recdef tsize ()
  "tsize BOTTOM h h' = 0"
  "tsize (I i) h h' = 0"
  "tsize (B b) h h' = 0"
  "tsize (R ref) h h' = 
     (case ref of
          Nullref \<Rightarrow> 0
       |  Ref loc \<Rightarrow> 
           (case (fmap_lookup h loc) of
                None \<Rightarrow> 0 
             |  Some n \<Rightarrow> 1 + tsize n h h'))"

primrec
  "deepcopy (C n refs) h h' = ((C n refs),h')" 
  "deepcopy (X fname n refs) h h' = ((X fname n refs),h')"
*)

primrec
  "deepcopy BOTTOM h h' = (BOTTOM,h')"
  "deepcopy (I i) h h' = ((I i),h')" 
  "deepcopy (B b) h h' = ((B b),h')" 

(*
  "deepcopy (R ref) h h' =  
     (case ref of
          Nullref \<Rightarrow> (R (Nullref),h')
       |  Ref loc \<Rightarrow> 
           (case (fmap_lookup h loc) of
                None \<Rightarrow> (R (Nullref),h')
             |  Some n \<Rightarrow> deepcopy n h h'))"


defs
    )

(R ref,h))"

primrec
     (let (nv,nh) = deepcopy (the (fmap_lookup h ref)) h h';
          l = freshloc (fmap_dom nh)
     in (R (Ref l),h))"

primrec

fmap_upd nh l nv
     let l = freshloc (fmap_dom h') ;
         (nv,h) = deepcopy (fmap_lookup h l) h (fmap_upd h' 

     (R (Ref (freshloc (fmap_dom h'))),
      fmap_upd h' (freshloc (fmap_dom h')) ()

)" 

defs

    in (e(x := (R (Ref l))),fmap_upd h' l (the (fmap_lookup h loc)))

let k = 

((R ref),

h')"
  "deepcopy (C n refs) h h' = ((C n refs),h')" 
  "deepcopy (X fname n refs) h h' = ((X fname n refs),h')"
*)

lemma dc1:  "deepcopy (I i) h h' = ((I i),h')"
  by auto

section "Coordination layer state"

datatype PC = peven | podd

consts
  pc :: "PC statefun" (* the program counter - sequential execution of boxes *)
  odd_st :: "BoxState statefun" (* state/mode of box *)
  even_st :: "BoxState statefun" (* state/mode of box *)
  (* box heaps *)
  evenheap :: "Heap statefun"
  oddheap  :: "Heap statefun"
  (* box buffer: 
     Q: not sure if the have a set location or not - guess not since emptyheaps 
        between calls *)
  even_res :: "HoVal statefun"
  odd_res :: "HoVal statefun"
  (* the wire heap *)
  wireheap :: "Heap statefun"
  (* the wires: pointers to the wire heap - consumed by expression layer ??? *)
  (* Q: Assumes w1 = NullRef is used for empty wire *)
  w1 :: "HoVal statefun"
  w2 :: "HoVal statefun"
  (* enables reasoning about resources - Q: one for each heap? *)
  rso1 :: "Rescomp statefun"
  rso2 :: "Rescomp statefun"

section "The Expession VDM layer"

text {* Full body, including a pattern match against a variable *}

(* FIX ME: change to returning heap and location on heap - this will be the box heap
   Q1: should values be copied from wire heap to box heap, and the expression layer
       given the box heap - or should expression layer use wire heap directly ??
   Q2: matchfail - return NullRef ???
*)

syntax 
 x1  :: "VarName"
 xin :: "VarName"

translations
"x1" == "(VN ''x1'')"
"xin" == "(VN ''xin'')"

constdefs iplus :: "HoVal => HoVal => HoVal"
"iplus x y == I ((theInt x)+(theInt y))"
constdefs iinc :: "HoVal => HoVal => HoVal"
"iinc x y == I ((theInt x)+(1::int))"

(* heap version, ie. arg is a pointer to a heap cell containing an int *)
constdefs incbody :: "Exp"
"incbody == CaseOneExp xin (PVar x1) (RPrimBin iinc x1 x1) (ValueExp BOTTOM)"

(* stack version, ie. arg is an int *)
constdefs incbodyI :: "Exp"
"incbodyI == (PrimBin iinc xin xin)"

theorem incbody_spec: "{} \<rhd> incbody : (\<lambda> E h hh v p. 
  (\<forall> i r . (E xin = (R (Ref r)) \<and> (fmap_lookup h r = Some (I i)))  \<longrightarrow> v = (I (i+1))))"
apply (simp add: incbody_def)
apply (rule vdmConseq)
prefer 2
apply (rule vdmCaseOne)
apply (rule vdmRPrimBin)
apply (rule vdmValue)
apply clarsimp
apply (erule_tac x="E(x1:=(R (Ref r)))" in allE)
apply (erule_tac x="R (Ref r)" in allE)
apply clarsimp
apply (erule impE)
apply (rule semPVar)
apply (simp add: iinc_def)
done

theorem incbodyI_spec: "{} \<rhd> incbodyI : (\<lambda> E h hh v p. 
  (\<forall> i r . (E xin = (I i))  \<longrightarrow> v = (I (i+1))))"
apply (simp add: incbodyI_def)
apply (rule vdmConseq)
prefer 2
apply (rule vdmPrimBin)
apply clarsimp
apply (simp add: iinc_def)
done

(* Q: not sure about the env. if a heap is provided then it need the
      reference to the value in the input heap. *)
consts
  binc :: "Heap \<Rightarrow> (HoVal \<times> Heap)"

(* defs
  deepcopy: "deepcopy loc h x e h' \<equiv> 
    let l = freshloc (fmap_dom h') 
    in (e(x := (R (Ref l))),fmap_upd h' l (the (fmap_lookup h loc)))"
*)

defs
  binc: "binc h \<equiv> let (v,h',R) = exe emptyEnv h incbody in (v,h')"

(* used for illustration *)

consts
  dummy :: "Heap \<Rightarrow> (Ref \<times> Heap)"

section "The coordination layer"

constdefs
  S' :: "temporal"
  "S' \<equiv> TEMP (sch$ = (if isExe \<and> $pc = #podd then #Super else #Execute))
           \<and> (isExe \<longrightarrow> pc$ = #peven)"

subsection "Even Box"

(* since the super-step is atomic, it has to be dealt with globally *)

consts
 evenoddExe :: "HoVal \<Rightarrow> Heap \<Rightarrow> Heap \<Rightarrow> HoVal*Heap*Rescomp"

defs
  evenoddExe: "evenoddExe v hwire hbox \<equiv>
    let (v',hbox') = deepcopy v hwire hbox in exe (emptyEnv(xin := v')) hbox' incbodyI"


(* 1: lift vdm to property to relevant HOL property *)

consts
  even :: "temporal"
  odd :: "temporal"
  super :: "temporal"
  init :: "temporal"
  program :: "temporal"

defs 
 even: "even \<equiv> TEMP
(if $pc \<noteq> #peven
 then Unchanged (w2,even_res,evenheap,even_st)
 else pc$ = #podd \<and> 
 (if $even_st = #Blocked
   then Unchanged (w2,even_res,even_st,evenheap,wireheap)
   else 
 (if $w2 = #BOTTOM
   then Unchanged (w2,evenheap,wireheap)
     \<and>  even_res$ = #BOTTOM 
     \<and>  even_st$ = #Matchfail
   else Unchanged evenheap 
    \<and> w2$ = #BOTTOM
    \<and> (even_res,evenheap,rso1)$ = evenoddExe<$w2,$wireheap,$evenheap>)))"
 odd: "odd \<equiv> TEMP
(if $pc \<noteq> #podd
 then Unchanged (w1,odd_res,oddheap,odd_st)
 else pc$ = #peven \<and> 
 (if $odd_st = #Blocked
   then Unchanged (w1,odd_res,odd_st,oddheap,wireheap)
   else 
 (if $w1 = #BOTTOM
   then Unchanged (w1,oddheap,wireheap)
     \<and>  odd_res$ = #BOTTOM 
     \<and>  odd_st$ = #Matchfail
   else Unchanged oddheap 
    \<and> w1$ = #BOTTOM
    \<and> (odd_res,oddheap,rso2)$ = evenoddExe<$w1,$wireheap,$oddheap>)))"

defs
 super: "super \<equiv> TEMP
    pc$ = #peven
 \<and> Unchanged (wireheap,evenheap,oddheap)
 \<and> (if $w1 \<noteq> #BOTTOM \<and> $even_res \<noteq> #BOTTOM
    then even_st$ = #Blocked \<and> Unchanged (w1,even_res)  
    else (if $even_res = #BOTTOM
    then even_st$ = #Runnable \<and> Unchanged (w1,even_res)
    else even_st$ = #Runnable \<and> w1$ = $even_res \<and> even_res$ = #BOTTOM))
 \<and> (if $w2 \<noteq> #BOTTOM \<and> $odd_res \<noteq> #BOTTOM
    then odd_st$ = #Blocked \<and> Unchanged (w2,odd_res)  
    else (if $odd_res = #BOTTOM
    then odd_st$ = #Runnable \<and> Unchanged (w2,odd_res)
    else odd_st$ = #Runnable \<and> w2$ = $odd_res \<and> odd_res$ = #BOTTOM))"
  

defs
  init: "init \<equiv> TEMP
    $sch = #Execute \<and> $pc = #peven
  \<and> $wireheap = #emptyHeap
  \<and> $(even_st,odd_st) = #(Runnable,Runnable)
  \<and> $(evenheap,oddheap) = #(emptyHeap,emptyHeap)
  \<and> $(even_res,odd_res) = #(BOTTOM,BOTTOM)
  \<and> $(w1,w2) = #(I 0,BOTTOM)"


defs
  program: "program \<equiv> TEMP
   init \<and> \<box>[S' \<and> (isExe \<longrightarrow> even \<and> odd) \<and> (isSup \<longrightarrow> super)]_(pc,sch,odd_st,
                   even_st,evenheap,oddheap,even_res,odd_res,wireheap,w1,w2)"

section "Properties"

consts EvenN :: "int set"
       OddN  :: "int set"

inductive EvenN OddN 
intros
 zero: "0 \<in> EvenN" 
 one:  "1 \<in> OddN"
 plus1: "n \<in> OddN \<Longrightarrow> (n+1) \<in> EvenN"
 plus2: "n \<in> EvenN \<Longrightarrow> (n+1) \<in> OddN"
 minus1: "n \<in> OddN \<Longrightarrow> (n-(1::int)) \<in> EvenN"
 minus2: "n \<in> EvenN \<Longrightarrow> (n-(1::int)) \<in> OddN"
 umin1: "n \<in> EvenN \<Longrightarrow> (-n) \<in> EvenN"
 umin2: "n \<in> OddN \<Longrightarrow> (-n) \<in> OddN"

lemmas hume_rews =
  intensional_rews all_after_eq all_before_eq
  after_before next_all_eq toBeforeVal toAfterVal
  isExe_def isSup_def

lemma vdmexe2: "\<lbrakk>{} \<rhd> e : P; (v,h',p) = exe E h e\<rbrakk> 
  \<Longrightarrow> P E h h' v p"
  by (simp add: vdmexe)

lemma vdmexe3: "\<forall> E h h' v p e P. ({} \<rhd> e : P) \<and> ((v,h',p) = exe E h e) \<longrightarrow>  P E h h' v p"
  by (simp add: vdmexe)


lemma evod1: "\<lbrakk>(v',h,r) = evenoddExe v h1 h2; v = I n \<rbrakk> \<Longrightarrow> v' = I (n+1)"
  apply (auto simp add: evenoddExe)
  apply (insert vdmexe2[OF incbodyI_spec])
  apply auto
  done

lemma evod1a: "(v',h',r) = evenoddExe (I n) h hh \<Longrightarrow> v' = I (n+1)"
  apply (auto simp add: evenoddExe)
  apply (insert vdmexe2[OF incbodyI_spec])
  apply auto
  done

lemma evod1a: "(I (n+1),h,r) = evenoddExe (I n) h1 h2"
  apply (auto simp add: evenoddExe)
  apply (insert vdmexe2[OF incbodyI_spec])
  oops

lemma evod2: "\<lbrakk>(v',h,r) = evenoddExe v h1 h2; v = I n; n \<in> EvenN\<rbrakk> \<Longrightarrow> (\<exists> k. v' = I k \<and> k \<in> OddN)"
  apply (auto simp add: evenoddExe)
  apply (insert vdmexe2[OF incbodyI_spec])
  apply (rule_tac x = "n+1" in exI)
  apply (insert evod1)
  apply auto
  apply (rule plus2)
  apply assumption
  done

lemma evod3: "\<lbrakk>(v',h',r) = evenoddExe (I n) h hh; n \<in> OddN\<rbrakk> \<Longrightarrow> (\<exists> k. v' = I k \<and> k \<in> EvenN)"
  apply (auto simp add: evenoddExe)
  apply (insert vdmexe2[OF incbodyI_spec])
  apply (rule_tac x = "n+1" in exI)
  apply (insert evod1)
  apply auto
  apply (rule plus1)
  apply assumption
  done

(* Possible aux *)
lemma eo1: "\<turnstile> program \<longrightarrow> \<box>(((\<exists> n. $w1 = #(I n)) \<or> $w1 = #BOTTOM)
                     \<and> ((\<exists> n. $w2 = #(I n)) \<or> $w2 = #BOTTOM)
                     \<and> ((\<exists> n. $even_res = #(I n)) \<or> $even_res = #BOTTOM)
                     \<and> ((\<exists> n. $odd_res = #(I n)) \<or> $odd_res = #BOTTOM))"
  apply (unfold program)
   apply (rule invmono)
   apply (unfold init)
   apply int_unlift
   apply (simp only: hume_rews)
   apply simp
   apply (rule preimpsplit)
   apply (simp_all only: hume_rews)
   prefer 2
  apply (simp only: unch_eq1, simp add: unch_def)
  apply pref_unlift
   apply (case_tac "w \<Turnstile> $sch")
   prefer 2
   apply (simp add: isExe_def isSup_def super)
  apply (simp only: unch_eq1, simp add: unch_def)
  apply (simp add: isExe_def isSup_def)
   apply (case_tac "w \<Turnstile> $pc")
   apply (simp add: odd, simp only: unch_eq1, simp add: unch_def)
   (* even step *)
   apply (simp only: even)
    apply (case_tac "(w \<Turnstile> $even_st) = Blocked")
   apply (simp only: unch_eq1, simp add: unch_def)
    apply (case_tac "(w \<Turnstile> $w2) = BOTTOM")
   apply (simp only: unch_eq1, simp add: unch_def)
   apply simp
   apply (intro impI,elim conjE)
   apply (simp only: evenoddExe Let_def)
   apply (simp only: hume_rews)
   apply clarsimp
   apply (subgoal_tac "\<forall> i r . ((emptyEnv(xin := I n)) xin = (I i))  \<longrightarrow> (w \<Turnstile> even_res$) = (I (i+1))")
   prefer 2
   apply (insert vdmexe3)
   apply (drule_tac x = "emptyEnv(xin := I n)" in spec)
   apply (drule_tac x = "w \<Turnstile> $evenheap" in spec)
   apply (drule_tac x = "w \<Turnstile> evenheap$" in spec)
   apply (drule_tac x = "w \<Turnstile> even_res$" in spec)
   apply (drule_tac x = "w \<Turnstile> rso1$" in spec)
   apply (drule_tac x = "incbodyI" in spec)
   apply (drule_tac x = "(\<lambda> E h hh v p. (\<forall> i r . (E xin = (I i))  \<longrightarrow> v = (I (i+1))))" in spec)
   apply (insert incbodyI_spec)
   apply simp
   apply simp
   (* odd step !!! *)
   apply (simp only: even odd)
    apply (case_tac "(w \<Turnstile> $odd_st) = Blocked")
   apply (simp only: unch_eq1, simp add: unch_def)
    apply (case_tac "(w \<Turnstile> $w1) = BOTTOM")
   apply (simp only: unch_eq1, simp add: unch_def)
   apply simp
   apply (intro impI,elim conjE)
   apply (simp only: evenoddExe Let_def)
   apply (simp only: hume_rews)
   apply clarsimp
   apply (subgoal_tac "\<forall> i r . ((emptyEnv(xin := I n)) xin = (I i))  \<longrightarrow> (w \<Turnstile> odd_res$) = (I (i+1))")
   prefer 2
   apply (insert vdmexe3)
   apply (drule_tac x = "emptyEnv(xin := I n)" in spec)
   apply (drule_tac x = "w \<Turnstile> $oddheap" in spec)
   apply (drule_tac x = "w \<Turnstile> oddheap$" in spec)
   apply (drule_tac x = "w \<Turnstile> odd_res$" in spec)
   apply (drule_tac x = "w \<Turnstile> rso2$" in spec)
   apply (drule_tac x = "incbodyI" in spec)
   apply (drule_tac x = "(\<lambda> E h hh v p. (\<forall> i r . (E xin = (I i))  \<longrightarrow> v = (I (i+1))))" in spec)
   apply (insert incbodyI_spec)
   apply simp
   apply (simp only: unch_eq1, simp add: unch_def)
   done

(* Main theorem *)
theorem main: "\<turnstile> program \<longrightarrow> \<box>( (\<forall> n. $w1 = #(I n) \<longrightarrow> #n \<in> #EvenN) 
                              \<and> (\<forall> n. $w2 = #(I n) \<longrightarrow> #n \<in> #OddN) 
                              \<and> (\<forall> n. $even_res = #(I n) \<longrightarrow> #n \<in> #EvenN) 
                              \<and> (\<forall> n. $odd_res = #(I n) \<longrightarrow> #n \<in> #OddN))" 
  apply (unfold program) 
  apply (rule spec_inv2_mono)
  apply (rule eo1[unfolded program])
   apply (rule invmono) 
   apply (unfold init) 
   apply int_unlift 
   apply (simp add: all_before_eq) 
  apply (simp add: zero) 
   apply (rule preimpsplit) 
   apply (simp_all only: next_all_eq after_before) 
   prefer 2
  apply (simp only: unch_eq1, simp add: unch_def) 
  apply pref_unlift 
   apply (case_tac "w \<Turnstile> $sch") 
   prefer 2 
   apply (simp add: isExe_def isSup_def super) 
  apply (simp only: unch_eq1, simp add: unch_def) 
  apply (simp add: isExe_def isSup_def) 
   apply (case_tac "w \<Turnstile> $pc") 
   (* pc = even step *)
   apply (simp add: odd, simp only: unch_eq1, simp add: unch_def) 
   apply (simp only: even) 
    apply (case_tac "(w \<Turnstile> $even_st) = Blocked")   
   apply (simp only: unch_eq1, simp add: unch_def) 
    apply (case_tac "(w \<Turnstile> $w2) = BOTTOM") 
   apply (simp only: unch_eq1, simp add: unch_def) 
   apply simp_all
   apply (intro impI,elim conjE)
   apply (simp only: hume_rews)
   apply (elim exE)
   apply (subgoal_tac "(w \<Turnstile> even_res$) = I (n+1)")
   apply clarsimp
   apply (simp add: plus1 plus2)
   apply simp
   apply (rule evod1a)
   apply assumption
   (* pc = podd step *)
   apply (simp add: even, simp only: unch_eq1, simp add: unch_def) 
   apply (simp only: odd) 
    apply (case_tac "(w \<Turnstile> $odd_st) = Blocked")   
   apply (simp only: unch_eq1, simp add: unch_def) 
    apply (case_tac "(w \<Turnstile> $w1) = BOTTOM") 
   apply (simp only: unch_eq1, simp add: unch_def) 
   apply simp_all
   apply (intro impI,elim conjE)
   apply (simp only: hume_rews)
   apply (elim exE)
   apply (subgoal_tac "(w \<Turnstile> odd_res$) = I (n+1)")
   apply clarsimp
   apply (simp add: plus1 plus2)
   apply simp
   apply (rule evod1a)
   apply assumption
   done


end 
