theory Integrated
imports "Expr/GRUMPY" "Expr/VdmDerived" "Coord/Hume/Hume"
begin

consts exe :: "Env \<Rightarrow> Heap \<Rightarrow> Exp \<Rightarrow> (HoVal \<times> Heap \<times> Rescomp)"

axioms
 exe: "(exe E h e = (v,h',p)) = (E, h \<turnstile> e \<Down> (v,h',p))"

lemma vdmexe: "\<lbrakk>(v,h',p) = exe E h e; {} \<rhd> e : P\<rbrakk> 
  \<Longrightarrow> P E h h' v p"
proof -
  assume a1: "{} \<rhd> e : P"
    and  a2: "(v,h',p) = exe E h e"
  have "{} \<rhd> e : P \<Longrightarrow> {} \<Turnstile> e : P" by (rule soundness)
  with a1 have g1: "{} \<Turnstile> e : P" by simp
  have g1': "|\<Turnstile> {}" by (auto simp add: ctxt_valid_def)
  with g1 g1' have g1'': "\<Turnstile> e:P" 
    by (auto simp add: valid_in_ctxt_def)
   hence G: "(\<forall> E h h' v p . ((E, h \<turnstile> e \<Down> (v,h',p)) \<longrightarrow> P E h h' v p))"
     by (unfold valid_def)
  from a2 exe[symmetric] have g2: "E, h \<turnstile> e \<Down> (v,h',p)"
    by auto
  with G show ?thesis by auto
qed

subsection "A small example"

syntax 
 x1  :: "VarName"
 x2  :: "VarName"
 x3  :: "VarName"
 xin :: "VarName"
translations
"x1" == "(VN ''x1'')"
"x2" == "(VN ''x2'')"
"x3" == "(VN ''x3'')"
"xin" == "(VN ''xin'')"

constdefs iplus :: "HoVal => HoVal => HoVal"
"iplus x y == I ((theInt x)+(theInt y))"
constdefs iinc :: "HoVal => HoVal => HoVal"
"iinc x y == I ((theInt x)+(1::int))"

text {* Just the RHS of the body *}

constdefs incbody0 :: "Exp"
"incbody0 == (PrimBin iinc xin xin)"

(*
lemma "{} \<rhd> VarExp xin : (\<lambda> E h hh v p. (\<forall> i r . (E xin = (R (Ref r))  \<longrightarrow> v = (R (Ref r)))))"
apply (rule vdmConseq)
prefer 2
apply (rule vdmVar)
apply clarsimp
done
*)

text {* Prove specification, in form of an Assertion, for the body of incbox *}

lemma ib0: "{} \<rhd> incbody0 : (\<lambda> E h hh v p. (\<forall> i r . (E xin = (I i))  \<longrightarrow> v = (I (i+1))))"
apply (simp add: incbody0_def)
thm vdmConseq
apply (rule vdmConseq)
prefer 2
apply (rule vdmPrimBin)
apply clarsimp
apply (simp add: iinc_def)
done

text "unlift assertion to HOL conjecture"

lemma assumes a1: "(v,h',p) = exe E h incbody0"
  shows "(\<forall> i r . (E xin = (I i))  \<longrightarrow> v = (I (i+1)))"
using a1 ib0 by (rule vdmexe)

end 
