theory Tbox = ListCopy:

(* ----------------------------------------------------------------------------- *)

(* box-interface via shallow copying; ToDo: move it into another file  *)


consts 
 mkHeap :: "Locn set \<Rightarrow> Heap \<Rightarrow> Heap"
defs
 (*  mkHeap: "mkHeap U h \<equiv> fimap (\<lambda> l . if (l:U) then fmap_lookup h l else fmap_lookup emptyfinmap l)" *)
 mkHeap: "mkHeap U h \<equiv> fimap (empty ++ (themap h)|`U)"

syntax
 "_mkHeap" :: "Locn set \<Rightarrow> Heap \<Rightarrow> Heap" ("(_ ''| _)" [50,50] 90)

translations
 "_mkHeap"     \<rightleftharpoons> "mkHeap" 

lemma bonzo13: "\<lbrakk> {} \<rhd> e : (\<lambda> E h h' v p. (\<forall> wh wh'. h = mkHeap U wh \<and> wh' = mkHeap U' h' \<longrightarrow> Q U U' E wh wh'  v p)) ;
                  h = mkHeap U wh ; wh' = mkHeap U' h' ; E, h \<turnstile> e \<Down> (v,h',p) \<rbrakk>
                \<Longrightarrow> Q U U' E wh wh' v p"
apply (drule soundness)
apply (simp add: ctxt_valid_def valid_in_ctxt_def valid_def)
done

consts rr :: "Locn"
consts foo :: "FunName"

axioms fooAss: "{} \<rhd> (CallFunExp foo [xin]) : (\<lambda> E h h' v p. v = (I 1) \<and> fmap_lookup h' rr = Some (I 1) )"

lemma mkHeap_in: "\<lbrakk> fmap_lookup h r = a; r \<in> U \<rbrakk> \<Longrightarrow> fmap_lookup (mkHeap U h) r = a"
apply (simp add: mkHeap)
apply auto
sorry

lemma ex1: "\<lbrakk>  rr : U' ; h = mkHeap U wh ; wh' = mkHeap U' h' ; E, h \<turnstile> (CallFunExp foo [xin]) \<Down> (v,h',p) \<rbrakk>
       \<Longrightarrow> fmap_lookup wh' rr = Some (I 1)"
apply (rule bonzo13)
prefer 3
apply simp
apply (rule vdmConseq)
 prefer 2 apply (insert fooAss) apply assumption
apply clarsimp
prefer 2
apply simp
apply (rotate_tac -2)
apply (erule thin_rl)
apply (rule mkHeap_in)
apply simp
apply simp
(* ??? *)
oops

axioms fooAss2: "{} \<rhd> (CallFunExp foo [xin]) : (\<lambda> E h h' v p. card (fmap_dom h') \<le> card (fmap_dom h))"

lemma ex2: "\<lbrakk>  h = mkHeap U wh ; wh' = mkHeap U' h' ; E, h \<turnstile> (CallFunExp foo [xin]) \<Down> (v,h',p) \<rbrakk>
       \<Longrightarrow> card (fmap_dom wh') \<le> size U'"
apply (simp add: mkHeap)
oops

(*
apply (drule soundness)
apply (simp add: ctxt_valid_def valid_in_ctxt_def valid_def)
apply (erule_tac x="E" in allE)
apply (erule_tac x="mkHeap U wh" in allE)
apply (erule_tac x="h'" in allE)
apply (erule_tac x="v" in allE)
apply (erule_tac x="p" in allE)
apply (erule impE)
apply assumption
apply (erule_tac x="wh" in allE)
apply simp
apply (erule_tac x="n1" in allE)
apply (erule_tac x="r1" in allE)
apply (erule_tac x="U1" in allE)
apply clarsimp
apply (erule impE)
apply (rule conjI)
apply simp
apply (rule_tac x="n2" in exI)
apply (rule_tac x="U2" in exI)
apply simp
defer 1
apply (subgoal_tac "mkHeap U1 wh = wh")
apply simp
oops
*)

consts boxexe' :: "(Locn set) \<Rightarrow> (Locn set) \<Rightarrow> Env \<Rightarrow> Heap \<Rightarrow> Exp \<Rightarrow> (HoVal \<times> Heap \<times> Rescomp)"
axioms
 boxexe': "(boxexe' U U' E wh e = (v,wh',p)) = (\<exists> h h'. h = mkHeap U wh \<and> wh' = mkHeap U' h' \<and> E, h \<turnstile> e \<Down> (v,h',p))"

lemma vdmboxexe': "\<lbrakk> {} \<rhd> e : (\<lambda> E h h' v p. (\<forall> wh wh'. h = mkHeap U wh \<and> wh' = mkHeap U' h' \<longrightarrow> Q U U' E wh wh'  v p)) ;
                     boxexe' U U' E wh e = (v,wh',p) \<rbrakk>
                \<Longrightarrow> Q U U' E wh wh' v p"
apply (simp add: boxexe')
apply clarsimp
apply (drule soundness)
apply (simp add: ctxt_valid_def valid_in_ctxt_def valid_def)
done


lemma ex3: "\<lbrakk>  (n1,r1,U,wh):mList ; boxexe' U U' E wh (CallFunExp copy [xin]) = (v,wh',p) \<rbrakk> 
       \<Longrightarrow> (\<exists> n2 r2 . v = R (Ref r2) \<and> (n2,r2,U',wh'):mList)"
apply (rule vdmboxexe')
apply (rule vdmConseq)
apply (insert copy_resources_ok)
prefer 2
apply simp
prefer 2
apply simp
apply clarsimp
apply (rotate_tac -2)
apply (erule thin_rl)
apply (simp add: copyAss_def)
apply (erule_tac x="n1" in allE)
apply (erule impE)
apply (rule_tac x="r1" in exI)
apply (rule conjI)
defer 1
apply (rule_tac x="U" in exI)
oops

lemma ex4: "\<lbrakk>  (n1,r1,U,wh):mList ; boxexe' U U' E wh (CallFunExp copy [xin]) = (v,wh',p) \<rbrakk> 
       \<Longrightarrow> card (fmap_dom wh') \<le> size U'"
apply (simp add: boxexe')
apply clarsimp
apply (simp add: mkHeap)
(* should be trivial, based on map_restrict *)
oops


consts boxexe :: "Env \<Rightarrow> Heap \<Rightarrow> Exp \<Rightarrow> (HoVal \<times> Heap \<times> Rescomp)"

(*
axioms
 boxexe: "(boxexe E h e = (v,h',p)) = (\<exists> h h' n1 r1 U1 n2 r2 U2 . E xin = (R (Ref r1)) \<and> (n1,r1,U1,h):mList \<and> v = R (Ref r2) \<and> (n2,r2,U2,h'):mList \<and> (E, h \<turnstile> e \<Down> (v,h',p)))"

lemma boxexeI: "\<lbrakk> (\<exists> h h' n1 r1 U1 n2 r2 U2 . E xin = (R (Ref r1)) \<and> (n1,r1,U1,h):mList \<and> v = R (Ref r2) \<and> (n2,r2,U2,h'):mList \<and> (E, h \<turnstile> e \<Down> (v,h',p)))\<rbrakk>
                \<Longrightarrow> (boxexe E h e = (v,h',p))"
sorry

lemma boxexeE: "\<lbrakk> (boxexe E h e = (v,h',p)) \<rbrakk> 
                \<Longrightarrow> (\<exists> h h' n1 r1 U1 n2 r2 U2 . E xin = (R (Ref r1)) \<and> (n1,r1,U1,h):mList \<and> v = R (Ref r2) \<and> (n2,r2,U2,h'):mList \<and> (E, h \<turnstile> e \<Down> (v,h',p)))"
sorry
*)

(* execution of expression level code, with shallow copy of the wireheap to/from box heap *)
axioms
 boxexe: "(boxexe E wh e = (v,wh',p)) = (\<exists> h n1 r1 U1 n2 r2 U2 . E xin = (R (Ref r1)) \<and> (n1,r1,U1,h):mList \<and> h = mkHeap U1 wh \<and> v = R (Ref r2) \<and> (n2,r2,U2,h'):mList \<and> wh' = mkHeap U2 h' \<and> (E, h \<turnstile> e \<Down> (v,h',p)))"

lemma boxexeI[rule_format]: "(\<exists> h h' n1 r1 U1 n2 r2 U2 . E xin = (R (Ref r1)) \<and> (n1,r1,U1,h):mList \<and> h = mkHeap U1 wh \<and> v = R (Ref r2) \<and> (n2,r2,U2,h'):mList \<and> wh' = mkHeap U2 h' \<and> (E, h \<turnstile> e \<Down> (v,h',p))) 
                \<longrightarrow> (boxexe E wh e = (v,wh',p))"
apply (simp add: boxexe)
sorry

lemma boxexeE[rule_format]: "(boxexe E wh e = (v,wh',p)) 
                \<longrightarrow> (\<exists> h h' n1 r1 U1 n2 r2 U2 . E xin = (R (Ref r1)) \<and> (n1,r1,U1,h):mList \<and> h = mkHeap U1 wh \<and> v = R (Ref r2) \<and> (n2,r2,U2,h'):mList \<and> wh' = mkHeap U2 h' \<and> (E, h \<turnstile> e \<Down> (v,h',p)))"
apply (simp add: boxexe)
sorry

consts boxexe0 :: "VarName \<Rightarrow> Env \<Rightarrow> Heap \<Rightarrow> Exp \<Rightarrow> (HoVal \<times> Heap \<times> Rescomp)"

axioms
 boxexe0: "(boxexe0 x E wh e = (v,wh',p)) = (\<exists> h h' n1 r1 U1 n2 r2 U2 . h = mkHeap U1 wh \<and> E x = (R (Ref r1)) \<and> (n1,r1,U1,wh):mList \<and> v = R (Ref r2) \<and> (n2,r2,U2,wh'):mList \<and> wh' = mkHeap U2 h' \<and> (E, h \<turnstile> e \<Down> (v,h',p)))"

lemma boxexe0I: "\<lbrakk> (\<forall> h h' n1 r1 U1 n2 r2 U2 . E x = (R (Ref r1)) \<and> (n1,r1,U1,h):mList \<and> h = mkHeap U1 wh \<and> v = R (Ref r2) \<and> (n2,r2,U2,h):mList \<and> wh' = mkHeap U2 h' \<longrightarrow> (E, h \<turnstile> e \<Down> (v,h',p))) \<rbrakk>
                \<Longrightarrow> (boxexe0 x E wh e = (v,wh',p))"
sorry 
(* by (simp add: boxexe) *)

lemma boxexe0E: "\<lbrakk> (boxexe0 x E wh e = (v,wh',p)) \<rbrakk>
                \<Longrightarrow> (\<forall> h h' n1 r1 U1 n2 r2 U2 . E x = (R (Ref r1)) \<and> (n1,r1,U1,h):mList \<and> h = mkHeap U1 wh \<and> v = R (Ref r2) \<and> (n2,r2,U2,h):mList \<and> wh' = mkHeap U2 h' \<longrightarrow> (E, h \<turnstile> e \<Down> (v,h',p)))"
sorry


(* hardwired well-typed-ness: input is a list, output is a list *)
lemma vdmexe4[rule_format]: "\<forall> E wh wh' wv f x P. ({} \<rhd> CallFunExp f [x] : (\<lambda> E h h' v p . \<forall> n1 r1 U1 n2 r2 U2 . E x = (R (Ref r1)) \<and> (n1,r1,U1,h):mList \<and> h = mkHeap U1 wh \<and> v = R (Ref r2) \<and> (n2,r2,U2,h):mList \<and> wh' = mkHeap U2 h' \<and> v = wv \<and> wp = p \<longrightarrow> P E h h' wv wp))
                \<longrightarrow>  P E wh wh' wv wp"
sorry

(*
lemma vdmexe5[rule_format]: "\<lbrakk> boxexe E wh (CallFunExp f [x]) = (wv,wh',p) ; 
                               ({} \<rhd> CallFunExp f [x] : (\<lambda> E h h' v p . \<forall> n1 r1 U1 n2 r2 U2 . E x = (R (Ref r1)) \<and> (n1,r1,U1,h):mList \<and> wh = mkHeap U1 h \<and> v = R (Ref r2) \<and> (n2,r2,U2,h'):mList \<and> h' = mkHeap U2 wh' \<and> v = wv \<and> wp = p \<longrightarrow> P E h h' wv wp)) \<rbrakk>
                             \<Longrightarrow> P E wh wh' wv wp"
*)
lemma vdmexe5[rule_format]: "\<lbrakk> boxexe E wh (CallFunExp f [xin]) = (wv,wh',p) ; 
                               ({} \<rhd> CallFunExp f [xin] : (\<lambda> E h h' v p . \<forall> n1 r1 U1 n2 r2 U2 . E xin = (R (Ref r1)) \<and> (n1,r1,U1,h):mList \<and> h = mkHeap U1 wh \<and> v = R (Ref r2) \<and> (n2,r2,U2,h'):mList \<and> h' = mkHeap U2 wh' \<and> v = wv \<and> wp = p \<longrightarrow> P E h h' wv wp)) \<rbrakk>
                             \<Longrightarrow> P E wh wh' wv wp"
(*
apply (drule soundness)
apply (drule boxexeE)
apply clarsimp
apply (simp add: ctxt_valid_def valid_in_ctxt_def valid_def)
apply (erule_tac x="E" in allE)
apply (erule_tac x="mkHeap U1 wh" in allE)
apply (erule_tac x="h'" in allE)
apply (erule_tac x="R (Ref r2)" in allE)
apply (erule_tac x="p" in allE)
apply (erule impE)
apply simp
apply (erule_tac x="n1" in allE)
apply (erule_tac x="r1" in allE)
apply (erule_tac x="U1" in allE)
apply clarsimp
apply (erule impE)
apply (rule conjI)
apply simp
apply (rule_tac x="n2" in exI)
apply (rule_tac x="U2" in exI)
apply simp
defer 1
apply (subgoal_tac "mkHeap U1 wh = wh")
apply simp
*)
sorry

lemma vdmexe05[rule_format]: "\<lbrakk> boxexe0 x E wh (CallFunExp f [xin]) = (wv,wh',p) ; 
                               ({} \<rhd> CallFunExp f [xin] : (\<lambda> E h h' v p . \<forall> n1 r1 U1 n2 r2 U2 . E x = (R (Ref r1)) \<and> (n1,r1,U1,h):mList \<and> h = mkHeap U1 wh \<and> v = R (Ref r2) \<and> (n2,r2,U2,h'):mList \<and> h' = mkHeap U2 wh' \<and> v = wv \<and> wp = p \<longrightarrow> P E h h' wv wp)) \<rbrakk>
                             \<Longrightarrow> P E wh wh' wv wp"
sorry

(*
constdefs copyExeAss: "\<lambda> vin vout Uin Uout. (\<forall> n r . (E (hd zs) = (R (Ref r)) \<and> (n,r,Uin,h):mList  
                            \<longrightarrow> (card (fmap_dom h') \<le> card (fmap_dom h) + n + 1) \<and> (\<exists> rv Uv. v = R (Ref rv) \<and> (n,rv,Uout,h'):mList)))"

lemma "\<lbrakk> (\<exists> n r . E xarg = (R (Ref r)) \<and> (n,r,U,h):mList) ; h = mkHeap Uin wh ; wh' = mkHeap Uout h' \<rbrakk> 
       \<Longrightarrow> {} \<rhd> CallFunExp copy [xarg] : \<lambda> E h h' v p. card (fmap_dom h') \<le> size Uout"
*)

lemma wheap1: "h = mkHeap U wh \<Longrightarrow> card (fmap_dom h) = size U"
sorry

(* BOGUS lemma *)
(* boxexe (emptyEnv(xin := (R (Ref r1)))) wh (CallFunExp copy [xin]) = (v, wh', p) ;  *)
lemma "\<lbrakk> (n,r1,U,wh):mList ; n \<le> (11::nat) \<rbrakk>
      \<Longrightarrow> card (fmap_dom wh') \<le> size U + (11::nat)"
apply (rule vdmexe4)
apply (rule vdmConseq)
prefer 2
apply (insert copy_resources_ok)
apply simp
apply clarsimp
apply (simp add: copyAss_def)
apply (erule_tac x="n1" in allE)
apply (erule impE)
apply (rule_tac x="U1" in exI)
apply simp
apply clarsimp
apply (subgoal_tac "card (fmap_dom (mkHeap U1 ?wh)) = size U")
 apply fastsimp
 apply (rule wheap1)
 apply fastsimp
done

lemma "\<lbrakk> boxexe0 xin (emptyEnv(xin := (R (Ref r1)))) wh (CallFunExp copy [xin]) = (v, wh', p) ; (n,r1,U,wh):mList ; n \<le> (11::nat) \<rbrakk>
      \<Longrightarrow> card (fmap_dom wh') \<le> size U + (11::nat)"
apply (rule vdmexe05)
apply simp
apply (rule vdmConseq)
prefer 2
apply (insert copy_resources_ok)
apply simp
apply clarsimp
apply (erule thin_rl)
apply (rotate_tac 2)
apply (erule thin_rl)
apply (simp add: copyAss_def)
apply (erule_tac x="n1" in allE)
apply (erule impE)
apply (rule_tac x="U1" in exI)
apply simp
apply (insert wheap1)
apply simp
apply clarsimp
apply (subgoal_tac "(emptyEnv(xin := (R (Ref r1)))) xin = (R (Ref r1))")
 prefer 2 apply simp



apply (drule boxexeE)
apply clarsimp
apply (subgoal_tac "r1 = r1a")
apply clarsimp
apply (insert  copy_resources_ok)
apply (drule soundness)
apply (erule_tac x="n1a" in allE)
apply (erule impE)
apply (rule_tac x="U1a" in exI)
defer 1


apply (rule vdmexe5)
apply simp
apply (rule vdmConseq)
prefer 2
apply (insert copy_resources_ok)
apply simp
apply clarsimp
apply (simp add: copyAss_def)
apply (drule boxexeE)
apply clarsimp
apply (subgoal_tac "r1 = r1a")
apply clarsimp
apply (subgoal_tac "U1 \<subseteq> fmap_dom wh")
apply (erule_tac x="n" in allE)
apply (erule impE)
apply (rule_tac x="r1" in exI)
apply (rule conjI)
defer 1
apply (rule_tac x="U" in exI)
apply (subgoal_tac "mkHeap U1 wh = h")
apply clarsimp
defer 1
defer 1
apply clarsimp
apply (subgoal_tac "h = mkHeap U wh")
apply (frule wheap1)
apply clarsimp
apply (case_tac "n < 11")
 apply simp
 apply simp


oops

end